Package org.apache.lucene.codecs.lucene92

## Class Lucene92HnswVectorsReader

- java.lang.Object
- - org.apache.lucene.codecs.KnnVectorsReader
  - - org.apache.lucene.codecs.lucene92.Lucene92HnswVectorsReader

- All Implemented Interfaces:
    `Closeable`, `AutoCloseable`, `Accountable`

      public final class Lucene92HnswVectorsReader
      extends KnnVectorsReader

  Reads vectors from the index segments along with index data structures supporting KNN search.
  WARNING: This API is experimental and might change in incompatible ways in the next release.

- - ### Field Summary

    - ### Fields inherited from interface org.apache.lucene.util.Accountable

      `NULL_ACCOUNTABLE`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `checkIntegrity()` | Checks consistency of this reader.
    `void` | `close()` |
    `HnswGraph` | `getGraph​(String field)` | Get knn graph values; used for testing
    `VectorValues` | `getVectorValues​(String field)` | Returns the `VectorValues` for the given `field`.
    `long` | `ramBytesUsed()` | Return the memory usage of this object in bytes.
    `TopDocs` | `search​(String field, float[] target, int k, Bits acceptDocs, int visitedLimit)` | Return the k nearest neighbor documents as determined by comparison of their vector values for this field, to the given vector, by the field's similarity function.

    - ### Methods inherited from class org.apache.lucene.codecs.KnnVectorsReader

      `getMergeInstance`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.apache.lucene.util.Accountable

      `getChildResources`

- - ### Method Detail

    - #### ramBytesUsed

          public long ramBytesUsed()

      Description copied from interface: `Accountable`
      Return the memory usage of this object in bytes. Negative values are illegal.

    - #### checkIntegrity

          public void checkIntegrity()
                              throws IOException

      Description copied from class: `KnnVectorsReader`
      Checks consistency of this reader.

      Note that this may be costly in terms of I/O, e.g. may involve computing a checksum value against large data files.

      Specified by:
        `checkIntegrity` in class `KnnVectorsReader`
      Throws:
        `IOException`

    - #### getVectorValues

          public VectorValues getVectorValues​(String field)
                                       throws IOException

      Description copied from class: `KnnVectorsReader`
      Returns the `VectorValues` for the given `field`. The behavior is undefined if the given field doesn't have KNN vectors enabled on its `FieldInfo`. The return value is never `null`.
      Specified by:
        `getVectorValues` in class `KnnVectorsReader`
      Throws:
        `IOException`

    - #### search

          public TopDocs search​(String field,
                                float[] target,
                                int k,
                                Bits acceptDocs,
                                int visitedLimit)
                         throws IOException

      Description copied from class: `KnnVectorsReader`
      Return the k nearest neighbor documents as determined by comparison of their vector values for this field, to the given vector, by the field's similarity function. The score of each document is derived from the vector similarity in a way that ensures scores are positive and that a larger score corresponds to a higher ranking.

      The search is allowed to be approximate, meaning the results are not guaranteed to be the true k closest neighbors. For large values of k (for example when k is close to the total number of documents), the search may also retrieve fewer than k documents.

      The returned `TopDocs` will contain a `ScoreDoc` for each nearest neighbor, in order of their similarity to the query vector (decreasing scores). The `TotalHits` contains the number of documents visited during the search. If the search stopped early because it hit `visitedLimit`, it is indicated through the relation `TotalHits.Relation.GREATER_THAN_OR_EQUAL_TO`.

      The behavior is undefined if the given field doesn't have KNN vectors enabled on its `FieldInfo`. The return value is never `null`.

      Specified by:
        `search` in class `KnnVectorsReader`
      Parameters:
        `field` - the vector field to search
        `target` - the vector-valued query
        `k` - the number of docs to return
        `acceptDocs` - `Bits` that represents the allowed documents to match, or `null` if they are all allowed to match.
        `visitedLimit` - the maximum number of nodes that the search is allowed to visit
      Returns:
        the k nearest neighbor documents, along with their (searchStrategy-specific) scores.
      Throws:
        `IOException`

    - #### getGraph

          public HnswGraph getGraph​(String field)
                             throws IOException

      Get knn graph values; used for testing
      Throws:
        `IOException`

    - #### close

          public void close()
                     throws IOException

      Throws:
        `IOException`